; Copyright Formcroft Ltd 1997-1999
 .model small.486.code
 include always.inc; Assembler shorthands like 'Bptr' for 'byte ptr'.
 include declares.inc; Symbolic constants, macros, records, structures.
; Syntax actions, made public to fulfill slots in syntax tables.
 PUBLIC Action0;   the action for an operand. (Not numbered in the BNF)
 PUBLIC Action1;   assignment at =
 PUBLIC Action2;   end of keyword instruction
 PUBLIC Action3;   end of command
 PUBLIC Action6;    PARSE VALUE
 PUBLIC Action10;   a binary op
 PUBLIC Action11;   a prefix
 PUBLIC Action12;   comparisons
 PUBLIC Action18;   a function name or after CALL
 PUBLIC Action50;   after the subject of PARSE
 PUBLIC Action51;   ARG verb
 PUBLIC Action52;   PULL verb
 PUBLIC Action53;   Trigger
 PUBLIC Action55;   +-=
 PUBLIC Action56;   UPPER
 PUBLIC Action57;   after template
 PUBLIC Action58;   comma in template
 PUBLIC Action20;   at THEN
 PUBLIC Action21;   at ELSE
 PUBLIC Action22;   end of if
 PUBLIC Action23;   end of select
 PUBLIC Action24;   end of otherwise
 PUBLIC Action25;   end of when
 PUBLIC Action26;   PROCEDURE
 PUBLIC Action28;   ITERATE/LEAVE, no VAR
 PUBLIC Action29;   ITERATE/LEAVE with VAR
 PUBLIC Action30;   do-end without var after.
 PUBLIC Action31;   var after do-end
 PUBLIC Action32;   end of do.
 PUBLIC Action33;   dorep done
 PUBLIC Action34;   While
 PUBLIC Action35;   Until
 PUBLIC Action36;   FOREVER
 PUBLIC Action37;   WHILE/UNTIL
 PUBLIC Action381;   TO
 PUBLIC Action382;   BY
 PUBLIC Action383;   FOR
 PUBLIC Action41;   missing expressions in a list
 PUBLIC Action43;   a function completes
 PUBLIC Action44;   CALL Ftn without expression list
 PUBLIC Action45;   CALL Ftn with expression list
 PUBLIC Action60;   callon spec.
 PUBLIC Action61;   after condition
 PUBLIC Action62;   OFF
 PUBLIC Action70;   ADDRESS instruction
 PUBLIC Action71;   INPUT resources
 PUBLIC Action72;   OUTPUT resources
 PUBLIC Action73;   ERROR resources
 PUBLIC Action74;   APPEND
 PUBLIC Action75;   Environment name
 PUBLIC Action80;   after numeric.
 PUBLIC Action90;   Expression ends
 PUBLIC Action91;   Clause end
 EXTERN $CondKeys:near, $WithKey:near; To alter lexical keyword lookups.
 EXTERN Bifs:near; The table of spellings.
 EXTERN PcodeBif:near
 EXTERN StrictFlags:near; Used in ConstValue

OpFactAh is <ah>   ; Byte of facts about the operator.
OpFactAl is <al>   ; Ditto
;------------------------------------------------------------------------------
; Lookups need access to the Symbols segment so the discipline is to keep
; SymbolsEs in play, as with the rest of compile activity. The segment Pcode
; is made in is addressed by GS. (As it is also in execution, except during
; Compaction). DS and FS do not have specific uses.
; BX is not needed for the attributes table during Pcode generation so can be
; used for the Pcode cursor, CursorBx. (Picked up from Z.Cursor, current
; position in generated Pcode). There are other uses.
; The principal use of DI is as StackDi, with copy to Z.Stack.
; (Other uses, particularly during Lookup.)
; On entry to Actions, SI addresses the parser stack (use S. and ParseSi) but
; it can be reused.
;------------------------------------------------------------------------------

;------------------------------------------------------------------------------
; Before being put in Pcode, operands are given a compact numbering by Lookup.
;------------------------------------------------------------------------------
comment~ On first sight, a symbol or string is written to where Z.Symbols points
and (Z.Clause,Tailed) notes whether it is qualified.  The question of when to do
Lookup is complicated.  Label definitions don't need to be seen by the parser so
they are looked up on first sight.  Doing a variable symbol early would be wrong
if it was actually a keyword.  Doing a variable symbol late (eg in an Action)
could be wrong when implied concatenate - both symbols would get read before any
lookup.  So best time for a variable symbol is when the parser shifts it.  But
in a case like A.B=F() it is required that the RHS be evaluated before B is
referenced so, for code making reasons, Lookup is held over until the RHS has
been done.  Holdover is on soft stack, is raw symbol when tailed, else result of
lookup.  Constants and label uses could be done at any stage - are currently
being done at RealShift in parser (simplest for line number in messages)
TokNum is $VAR_SYMBOL when a name is initially uppercased and stored.
The result, the latest thing looked up, is set in Z.Resolved.

The Lower and Higher fields are altered during lookup so it would be inefficient
to use any spare bits they have for information about the subject.  There are no
spare bits on Here since space for the names and literals may be a limiting
factor on program size.  We need to pack all the subject data into the one
remaining word.  We want to hold offsets of code for the labels, and info on
which bif.  At 0.1% loss of code size max, we can take 66 of the 2**16 values
for the bifs.  Slightly inefficient , but what else?  (Leaving bif lookup until
end-of-source would prevent making bif-dependent code on the one pass.)
(Actually now types-with-constants is implemented it could be done that way.)

~
 Assert Vshape.Pair eq 0;
 Assert Vshape.Lower eq 0;
; During the following loop, ArrayBx locates a tree that may contain the
; searched for value, eventually going to zero if the value is not found
; anywhere.
Find:; Takes ds and Z.Middles,LookLabel, LookBin.
; Z.Symbols addresses string to look up.
; Searches (and maybe adds item) according to info in DS header.
; The header of segment ds has zone offset of place that addresses the segment.
; On exit ds:bx is the matching item, es:dx::ax addresses the string, and
; Carry on if the item is new. The relevant probe will have been changed
; and Z.Middles.LookLabel will be off.
; SegOffDi will be zone offset (how much of this matters?).
 mov ArrayBx,Hd.Probe
 Qry Z.Middles,LookLabel,LookBinjz FindNewmov ArrayBx,Hd.Labels@@:
 Qry Z.Middles,LookBinjz @Fmov ArrayBx,Hd.TreeBin@@:
FindNew:; Enter here with ArrayBx set, eg zero to ensure isolated item.
 mov ToFindDx,He.Avail
 mov si,ToFindDxmovzx ToFindLenAx,SymbolsEs:Bptr[si]inc ToFindLenAx
; LowSi and HighDi are the offsets of slots (with the slots themselves
; containing offsets). Those slots are filled in by the subsequent iteration.
; Use the next available element for this newly developed place so that it
; will be in the right place if the subject is previously unknown.
 mov LowSi,Hd.Availlea HighDi,[LowSi+Vshape.Higher]
; In parallel with searching, the tree is being re-arranged to make the
; found (or new) item the root.  This has good performance characteristics
; when references to the same thing are clustered.
WhileArrayBx:TestReg ArrayBxjz LookNoFind
; Do the string (with length) compare.
LookLoop:push sipush di
 mov si,ToFindDxmov di,Vbx.Heremov cx,ToFindLenAx
 repe cmps SymbolsEs:Bptr[si],Bptr[di]pop dipop sijae SymbolsBelow
; We want the next probe to be at a higher place, so must set ArrayBx from
; Higher. At the same time the tree-rewriting info must be maintained.
; LowSi is set to locate a slot in an item where we followed the 'higher'
; locator.  We are stepping on even higher, so we can refill that slot
; (with an offset to where we are now probed) knowing that there is no
; risk that slot contained an offset to the thing we are looking for.
 mov [LowSi],ArrayBx; Complete prior iteration
 lea LowSi,Vbx.Higher; Note slot to pick up now
 mov ArrayBx,[LowSi]; Pick upjmp WhileArrayBx
; Found equality.
; Complete each of the two subtrees we have been making, one
; containing items lower than the probe and one containing higher values.
SymbolEq:mov ax,Vbx.Lowermov [LowSi],axmov ax,Vbx.Highermov [HighDi],ax
; Make everything one tree rooted at ArrayBx.
 mov si,Hd.Avail
 mov esi,Vshape.Pair[si]mov Vbx.Pair,esi
 mov SegOffDi,Hd.Link
 Qry Z.Middles,LookLabel,LookBinjnz FoundLabBin
 mov Hd.Probe,ArrayBx
@@:mov Z.Resolved,ArrayBxclcret; Subject found at ArrayBx.
FoundLabBin:btr Z.Middles,LookLabeljc FoundLabel
 Off Z.Middles,LookBinmov Hd.TreeBin,ArrayBxjmp @B
FoundLabel:mov Hd.Labels,ArrayBxjmp @B

SymbolsBelow:je SymbolEq
; This section by symmetry.
 mov [HighDi],ArrayBxlea HighDi,Vbx.Lowermov ArrayBx,[HighDi]
 TestReg ArrayBxjnz LookLoop
; It was not found. Complete the two isolated trees.  bx is zero.
LookNoFind:z Wptr[LowSi]z Wptr[HighDi]
; Commit the new item we have been making.
 mov SegOffDi,Hd.Link; Address a pointer in the Zone for the current segment
; Commit the symbol just looked up. This is the first use.
 call TakeSlotDi
 mov SymbolsEs,Z.Symbolsadd He.Avail,ToFindLenAx; For next symbol
 mov Vbx.Here,ToFindDx
 Qry Z.Middles,LookLabel,LookBinjnz NewLabBin
 mov Hd.Probe,ArrayBx
@@:mov Z.Resolved,ArrayBxstcret; Subject new at ArrayBx. SegOffDi active.
NewLabBin:btr Z.Middles,LookLabeljc NewLabel
 Off Z.Middles,LookBinmov Hd.TreeBin,ArrayBxjmp @B
NewLabel:mov Hd.Labels,ArrayBxjmp @B
;------------------------------------------------------------------------------
; The general Find mechanism is used to lookup variables, constants, ....
;------------------------------------------------------------------------------
Lookup:push axpush dxpush sipush di
; TokNumAh is argument, to determine what sort of lookup.
; If Z.Clause,Tailed off, Lookup what is at Symbols Avail, using the relevant
; tree. OpAppendCl is set.
; If Z.Clause,Tailed on,(and not a label) Lookup parts of what is at V. (SS:DI)
; Commits space in Symbols segment and Vars/Consts segment, for new item(s).
; Z.Resolved is a place to put the result. Also in ArrayBx.

; Select the segment we are searching and the tree within it.
; There are two possibilities for the segment - one for variables and the
; other for labels and constants. The latter contains three independent trees,
; making four possibilities for what is to be searched.
 btr Z.Middles,TakenConstantjc AsConstcmp TokNumAh,$VAR_SYMBOLjne AsConst
; Look up a variable symbol.
 btr Z.Clause,Tailedjc LookTailedmov ds,Z.Varscall Findjnc LookupRet
; The new current pool variable should initially say dropped.
 mov fs,Z.VarScopemov Vbxf.Dtype,$Dropped
 z Z.PoolPool; Shorter pools no longer useful.
; If it is a stem variable it takes two slots in the variable array.
; The first is for the default value, the second is special data for a stem.
; The second is not in any tree, uses the same characters as its symbol.
 mov si,He.Availcmp Bptr SymbolsEs:[si-1],'.'jne LookupRet
 push Vbx.Herecall TakeSlotDi
 mov Vbxf.Dtype,$Droppedpop Vbx.Here; So that second slot can be dumped.
 sub ArrayBx,$StrideV
LookupRet:
 pop di
if Debug
 call Consist
endif
 pop sipop dxpop axret

AsConst:Off Z.Clause,Tailedmov ds,Z.ConstsQry Z.Middles,LookLabeljnz AsLabel
; We will have to pop TokNumAh to ch because Find sets ToFindLenAx
 push axcall Findpop cxjnc LookupRet
; Dot as first of symbol makes it reserved, potential message.
; Unless it came as number or quoted.
 cmp ch,$CONST_SYMBOLjne @F
 mov si,ToFindDxcmp Bptr SymbolsEs:[si+1],'.'jne @F
 cmp ArrayBx,$?SIGLja Raise50p1
@@:
; We are here when the constant is looked up for the first time.  We have the
; symbol in literal form (Consts segment) but we also want it in ProgScope
; at run time. (With any needed conversion)
; Add a type byte after the new symbol.
 mov si,He.Availinc He.Availmov Bptr SymbolsEs:[si],$tChar
 mov ds,Z.ProgScope
;MASM .................................
; ToFindDx:ToFindLenAx includes a length byte.
 mov si,ToFindDxinc sidec ToFindLenAxcmp ToFindLenAx,7ja @F
; Simplest to always move 8 chars.
 Move Vbx,SymbolsEs:Vsid,edx
; Code for short string is $NullString plus length.
 mov Vbx.Dtype,$NullStringadd Vbx.Dtype,aljmp AsString
; Setup lengthy string.
@@:mov Vbx.Dtype,$AwayString
 mov Vbx.Len,axmov Vbx.Sg,SymbolsEsmov Vbx.Pt,si
AsString:jmp LookupRet

; Lookup of a label is in a tree devoted to labels.
AsLabel:push axcall Findpop axjnc LabelKnown
; Mark it amongst symbols as a label.
 mov si,He.Availmov Bptr SymbolsEs:[si],$tLabel
 mov Wptr SymbolsEs:[si+1],ZeroBpadd He.Avail,3
 push ds
 mov ds,Z.ProgScopemov Vbx.LabelValue,ZeroBp
 mov Vbx.LabelType,StringOrder(0,$Label)
 pop ds; (Z.Consts)
 TestReg TokNumAhjz WithColon
; First use of name, not with colon. See whether it is a Bif.
 mov di,ToFindDx
; Bifs have length between 3 and 10
 movzx ax,SymbolsEs:Bptr[di]
 cmp al,10ja NotBifcmp al,3jb NotBifinc di
; Bif tables with the code.
; Setup to search ones of relevant length.
 mov si,axmov cx,axadd si,simov dx,cs:(Bifs-4)[si]mov si,cs:(Bifs-6)[si]
BifLoop:push sipush dipush cxrepe cmpsb cs:[si],[di]
 pop cxpop dije BifFound
 pop siadd si,cxinc sicmp si,dxjne BifLoop
NotBif:jmp LookupRet

BifFound:movzx ax,Bptr cs:[si]; Bif compact number.
 pop siadd ax,$BifBase-$BifTagjmp SetLabel

LabelKnown:TestReg TokNumAhjnz LookupRet; Had it before, no colon here.
; Here for label that has colon.
 push dsmov ds,Z.ProgScopemov cx,Vbx.LabelValuepop ds
 JcxzQ WithColon; No colon or bif spelling before.
; Here are the awkward cases - there is a colon but we think we already
; know about the label.
 cmp cx,$BifBasejae DupBif
; To avoid the appearence of duplication as each label is scanned
; for a second time during Repass, the non-bif labels are given value
; one before that repass. (Can't be a genuine value because of
; the code segment header).
 dec cxjz WithColon
; Not a dup when rescan for Synch.
 cmp Z.Synch,ZeroBpjne LookupRet
; Here with something like ABC:NOP;ABC:
; This is allowed, the second one being for trace purposes.
; We leave the first one as it is, and make another that is not in any tree.
 z ArrayBxmov ds,Z.Consts
 push Hd.Probecall FindNewpop Hd.Probe
 mov si,He.Availmov Bptr SymbolsEs:[si],$tLabel
 add He.Avail,3jmp WithColon

DupBif:; Like CALL SUBSTR;...;SUBSTR:
 On Z.Program,Repass; Will need to start over knowing it is not a bif.
WithColon:; If it comes with a colon it isn't a bif.
 mov ax,Z.Cursor
SetLabel:; Put address in the Symbols, after the byte that tags a label.
 mov si,Vbx.Heremovzx cx,Bptr SymbolsEs:[si]
 add si,cxmov Wptr SymbolsEs:[si+2],ax
; Also set it under Z.ProgScope.  The copy under Z.Symbols is only used to
; reconstruct Z.ProgScope segment after program made dormant. NYI
 mov ds,Z.ProgScopemov Vbx.LabelValue,ax
; This already done??
 mov Vbx.LabelType,StringOrder(0,$Label)
; Maybe trace-only by reason of DO or SELECT
 cmp Hg.Original,ZeroBpjne LookupRet
 cmp Z.TraceOnly,ZeroBpje LookupRet
 mov Bptr Vbx.LabelType,1
 jmp LookupRet

; We have not done Between yet, so set Insert.TokLen.
Raise50p1:mov al,SymbolsEs:[si]mov Bptr Z.Insert.TokLen,al
 mov ax,MkMajMin(50,1)jmp Raise

TakeSlotDi:; SegOffDi identifies segment (in Zone).
; Take slot in segment, set bx to it.
; ds will match SegOffDi. May lead to ds update.
 mov ArrayBx,$StrideVxadd Hd.Avail,ArrayBx
; It will actually be .Vars or .Consts that is gaining a slot.
; .VarScope or .ProgScope to be matching size.
 mov es,Z.VarScopecmp SegOffDi,Zshape.Varsje @Fmov es,Z.ProgScope@@:
 add He.Avail,$StrideVmov Vbxe.Dtype,$Dropped
 cmp ArrayBx,Hd.Triggerjb @Fcall MoreSpaceEs
; The "shadows" are not tested for size; they expand when what they shadow does.
 push diadd SegOffDi,Zshape.VarScope-Zshape.Varscall MoreSpaceEspop di
 mov ds,Z.w[SegOffDi]; DS from Zone is new.
@@:mov SymbolsEs,Z.Symbolsret

comment~ The code for Tailed is 'on' calls Lookup recursively and eventually
exits via label LookupRet.  Here we pick symbol into parts and look them up
individually.  The Pcode made has the tail pieces followed by $pDots and a
counter of tail pieces.

~
; es is at Symbols but to cope with compaction must be picked up often.
; DS:SI has to be picked up again after each possible compaction.
; StackDi is not necessarily Z.Stack because of PARSE targets.
;; There must be an easier way!
LookTailed:On Z.Clause,WasTailed
  mov Z.Tail,StackDi
  call ToDsSiCx
; We don't want SymbolsSafe (& possible compaction) within the loop.
 push StackDimov di,He.Availadd di,cxcall SymbolsSafepop StackDi
 z OpAppendCxmovzx SymsZiDx,Bptr[LookupSi]
 inc LookupSiadd SymsZiDx,LookupSi; Runs from DS:SI up to DS:DX
 mov Z.SoFar,1
; Copy each component in turn to where it can be looked up, ie at Z.Symbols.
NextSym:mov StackDi,Z.Tail
 push OpAppendCxcall ToDsSiCxadd LookupSi,Z.SoFarpop OpAppendCx
 mov LengthAtBx,He.Availmov di,LengthAtBxz axstosb
@@:lodsbinc Z.SoFarstosbinc Bptr SymbolsEs:[LengthAtBx]
 cmp al,'.'je @Fcmp LookupSi,SymsZiDxjbe @B; Pretend dot at limit.
@@:; One name copied, including tailing dot.
 mov TokNumAh,$VAR_SYMBOL
 JcxzQ SymFirst; For first only, '.' is part of the name.
; After first, can be constant or null.  Lookup needs to be told Const/Var.
 dec Bptr SymbolsEs:[LengthAtBx]jz Absent
 mov al,Bptr SymbolsEs:[LengthAtBx]+1cmp al,'9'ja NotNumbcmp al,'0'jb NotNumb
Absent:mov TokNumAh,$CONST_SYMBOL; No matter if actually NUMBER
NotNumb:push cxcall Lookuppop cxmov ax,ArrayBx
 call Pcode2; Reference to part put on Pcode.
; Count of parts is in units of $StrideV.  BumpSym loops through the parts.
BumpSym:add OpAppendCl,$StrideVcmp si,SymsZiDxjb NextSym
; We are through the parts. Put (potential) opcode (and count) onto Pcode
; (We chose not to stack the tail components during compile.)
 sub OpAppendCx,2*$StrideV; Discount the stem itself. Less one for $pDots arg.
; Set up what caller of Lookup will see as the operand.
; Pcode addresses first of pair of elements.
 mov ArrayBx,Z.StemSymmov Z.Resolved,ArrayBxjmp LookupRet

SymFirst:push cxcall Lookuppop cxmov ax,ArrayBxmov Z.StemSym,axjmp BumpSym

;------------------------------------------------------------------------------
; Converting constants to desired value representation at compile time.
;------------------------------------------------------------------------------

comment~ Since the Dtype field says how a constant is represented we can always
hold a constant longterm as a string, and rely on there being a check (and
conversion) at places in the implementation where the argument has to be a
number. We can do better than that if the constant is written so that binary
and string versions convert to one another. (eg "99" not "099") Then we can
predict the likely use of the constant, store it in that form, and hence reduce
the converting at run time.

Best of all, though, is to allow for holding the number twice, once as string
and once as binary. Then we can select at compile time to reduce conversions.
That leads to notions of constants having an "attached" datatype and a different
lookup scope for different types. (A notion Rexx already has with labels being
in a different scope from variables.)

The simplest implementation would be to add the datatype byte to what Find looks
for, but that would preclude putting anything in the byte not related to lookup.
(Such as what radix a constant was originally in.) It also makes the end-to-end
scan of the symbols segment, where variables and constants are interleaved, more
problematic.

It is sounder to put the datatype byte after what is looked up, because there
are a few values available that cannot be confused with the length byte of
the next item. Also the lookups will be a touch faster when the trees are
separate.

There is a complication because constants are converted and looked up at
first sight since that gives the desired line number in any "its over-sized"
message.  At that time we don't know (or at least don't have a design that
knows) what datatype we want. So we always make a char version, and add a
binary later if needed.

Note that when the constant is used there will still need to be a test on
the argument (since it is just a value that might have come from a variable)
but the test will quickly find that no conversion is needed.  Even the test
is avoided for implementations of builtins since Bif$$ or Bifq$$ will have
ensured the arguments are put in appropriate format. (The bifs working always
at digits()=9 helps).

~
NotNumS:pop bxDownmov Z.Stack,StackDijmp NotNewConst

ConstValue:; Replace constant reference on stack by its value.
; ah says if we want the type enforced. (See DataType letters)
 cmp V.Dtype,$Constantjne ConstRet
ConstValueX:; This entry when that test inline.
 push sipush axpush bxpush cxpush edx
; Remember where Pcode will have to be patched if this operand changes.
 mov bx,V.PcodePosmov Z.PcodePos,bx
; Consider the constant's value.
 mov bx,V.WhichConmov fs,Z.ProgScopeMove V,Vbxf,edx
; It is bound to be string type at this stage.
 cmp ah,0jne NotGuess
; ah = 0 means numeric only if reversible (and written w/o quotes. NYI)
 call UpStack
 Move V,V0,edx
 push bx
 call NumDxBx; If it a number, V will be converted.
 jnz NotNumS
 call StrictFlags; Are the numeric and char exactly the same? (Drops stack two)
 pop bx
 mov SymbolsEs,Z.Symbols
 UpCaremov Z.Stack,StackDi
 jne NotNewConst
 mov ah,'N'
NotGuess:cmp ah,'N'jne NotNum
AsVar:; Will this string convert to number? Get flag to say.
 push bxcall NumDxBxpop bx
; Note that Carry will be on if reason for non-binary is non-number syntax, and
; this will feed back to caller.
 jnz AsVarX
; Is a fit to binary number. We need it added (if not there) to the
; symbols segment (with following $tBinary type byte) . A design choice whether
; to have it there as 8 bytes binary, as that converted to char, or as the
; original string.
 push StackDimov ds,Z.Constsmov si,Vbx.Here; Original symbol as string.
 movzx cx,Bptr SymbolsEs:[si]; Its length.
; Assure space with symbols for another copy.
 mov di,He.Availadd di,cxcall SymbolsSafesub di,cx
; Copy (with length) to tentative position of use.
 inc cxrep movsb [di],es:[si]
; Look in relevant tree for it.
 push bxmov ds,Z.ConstsOn Z.Middles,LookBincall Findpop sipop StackDi
 mov fs,Z.ProgScope
 jnc PcodeUsesxchg si,bx
; Now bx is the char-style constant, si is the new constant.
; Set value for the new item in ProgScope.
 Move V,Vbxfcall NumDxBx
 mov fs:Vsid.OverMant,ebxmov fs:Vsid.OverExpo,edx
; Add a type byte after the new symbol.
 mov si,He.Availinc He.Availmov Bptr SymbolsEs:[si],$tBinary
 jmp PcodeUses

AsVarX:mov V.Dtype,$Variablejmp NotNewConst

NotNum:cmp ah,' 'je AsVarcmp ah,'W'je AsVar; Variations of number.
 cmp ah,'O'jne NotNewConst
; Is it already single uppercase letter?
 cmp V.Dtype,$NullString+1jne @F
 mov cl,V.Stringcmp cl,'A'jb @Fcmp cl,'Z'jna NotNewConst
; Lookup desired constant.
@@:call UpperFirstAhmov ch,V.Stringmov cl,1
 mov si,He.Availmov Wptr SymbolsEs:[si],cx
 On Z.Middles,TakenConstantcall Lookup
; Reference to the old constant, in the Pcode already made, has to change.
PcodeUses:mov ax,Z.Resolvedmov si,Z.PcodePos
 cmp Z.Synch,ZeroBpjne @Fmov gs:[si],ax@@:
NotNewConst:mv ds,cspop edxpop cxpop bxpop axpop si
ConstRet:ret

UpperFirstAh:;Uppercase first char of the parameter, and retain only that.
; Also left in ah.
 push cxpush sicall ToDsSiCx
 mov ah,Bptr[si]cmp ah,'a'jb @Fcmp ah,'z'ja @Fand ah,0DFh@@:
 mov V.String,ahmov V.Dtype,$NullString+1
 pop sipop cxret

;------------------------------------------------------------------------------
; Pcode generation.
;------------------------------------------------------------------------------

comment~ On the representation of Pcode:

Here are the general routines for creating Pcode - they are called from the
places where particular language features are implemented.  Because the Intel
architecture is "Little-Endian", we can mix up one-byte and two-byte fields yet
distinquish them by their low bits.  So taking the value modulo 8:  Odd values
(1,3,5,7) mean this is an operator (and in one byte).  Zero means this is an
operand in the current variable pool.  Four means it is an operand from the pool
of constants (and system variables). Two is used for "subcodes" - things looked
at only in context and must be different from operators and operands. Six is
used to mark operands as targets.

If we ever go to a second pass of compilation that will, like a dumper, benefit
from an easy scan of Pcode. The modulo 8 mechanism distinguishes Pcodes,
subcodes, and operands. There is still a need to know what follows a Pcode.
Conceivably the actual values of the Pcodes might be put in ranges that
allow this to be deduced but since there will be at least a byte per opcode of
facts about the opcode available, it is flexible to use a couple of bits.
One bit will say if a number (in a byte) follows the opcode, for example a
bif number following a $pBif. The other bit will say whether there is a
reference following, for example the target of an assignment. (If both, the
number comes first.)

This leaves some special ones to be recognised individually:

$pAssignConst has two references. (So that the constant doesn't go via the
stack).

$pBool affects the meaning of the next operator.

Some operators have a jump address attached after them.  This seems a good
use for the actual value of opcodes because if we had long/short branches
we would want to test them in execution without going to fetch any facts
associated with the opcode.  $PjumpBase $PjumpCeil

(In theory we could use order to avoid the "has reference append" flag but that
conflicts with separating opcodes on whether they are shared with Bcode.)
~

PcodeOp:push si; Put operator in Pcode and make use of its attributes.
; Pick up flags about this Pcode, which comes in al.
; AX used. CX is input when OpAppendCx, not preserved. DX preserved.
; BX used and set to position of last thing placed.
; SI preserved.
; Make the Pcode, then look at effects on the operands.
 mov ah,alshr al,1mov bx,OpFlagsxlat cs:Bptr[bx]xchg ah,al
; Test for special case of implied operand.
 test OpFactAh,mask DownOnejz NotImplied
; This flag means "pop compile time stack".
; When PcodeOp called twice, once to advance original, once for trace, the
; compile time stack adjustment should happen once.
 Qry Z.Gen,DualOnlyjnz NotImplied
 mov StackDi,Z.Stackcmp StackDi,Z.Base0jne NotImplied
; If nothing to pop, an operand is implied, eg SAY;
 push axmov ax,$?Omittedcall Pcode2pop ax
 call UpStackjmp NotAssig

NotImplied:; Exit can come with and without operand. If any, it is used up.
 cmp al,$pExitjne @Fpush Z.Base0pop Z.Stack@@:
; Nov 99. Avoid assignment operator by flagging target.
 cmp al,$pAssignjne NotAssig
; Have to make the assign if it is for DO.
 Qry Z.Cancel,AssignDOjnz NotAssig
 add Z.Resolved,$CaseTargetjmp Targeted
NotAssig:; Dual mode code has a prefix to each operator.
 Qry Z.Gen,DualGenjz NoPfx
 btr Z.Cancel,BoolBeforejc @F
 push axmov al,$pTraceEventcall Pcode1Dpop ax
@@:cmp al,$pBooljne NoPfxOn Z.Cancel,BoolBefore
NoPfx:call Pcode1; Place the operator.
Targeted:test OpFactAh,mask AppendNumjz @F
; This an operator which needs a count after it, like Dots$$.
 xchg ax,OpAppendCxcall Pcode1xchg OpAppendCx,ax
@@:test OpFactAh,mask AppendRefjz NoRef
; This will be a variable reference, like the target of an Assign.
 push axmov ax,Z.Resolvedcall Pcode2pop ax
NoRef:
 cmp al,$PjumpBase; The actual value of the operator.jb NoSpace
 cmp al,$PjumpCeiljae NoSpace
; Two bytes of space to be later filled by FillJump, on original pass.
; When just synchronizing, content is not needed.
; When DualGen, the dual code will want the same values as the original, put
; in different places.  So copy out for that potential purpose.
 Qry Z.Gen,DualOnlyjnz @F
; Two different calls to PCodeOp can be involved.
 mov CursorBx,Z.Cursormove Z.Target,Wptr gs:[CursorBx],cx
@@:call Pcode2
 Qry Z.Gen,DualGenjz NoSpace
 move Wptr gs:[CursorBx],Z.Target,cx
NoSpace:
if Debug
 push ax
endif
 mov al,ah
; Now consider the involved operands.
 mov StackDi,Z.Stack
 Qry Z.Gen,DualOnlyjnz PcodeOpDone
 test OpFactAl,mask DownOnejz NotDow
; Maybe the top stack item is just being lost, eg $pBy, or maybe there were
; two items reduced to one by a binary operator. In the latter case we
; want to look twice for constants and to mark result as $Variable.
; In the former case there will be no type given for the result.
 Assert mask InTypes eq 0C0h
 test OpFactAl,mask InTypesjns NotArithBool
 mov ah,'N'call ConstValue
NotArithBool:
 Downmov Z.Stack,StackDi
 test OpFactAl,mask ResultTypejz NoChange
; Note that the tables cannot take care of everything, eg multiple downs and
; unknown result type when $pDots.
NotDow:
; There can be nothing on the stack, eg Exit$$.
 mov StackDi,Z.Stackcmp StackDi,Z.Base0je PcodeOpRet
 test OpFactAl,mask InTypesjns CharBest
 mov ah,'N'call ConstValue
CharBest:
 test al,mask ResultTypejz NoChange
 mov V.Dtype,$Variable
NoChange:

comment~ There is a lot more info available in static type analysis than
we can usefully use.  For example in ((A>B) & (C<D)) the $pAnd operation need
not check that its operands are 0 or 1, which it would have to do for (E & D).
But the check is cheap, so is it worth having opcodes for variations of And,
Or, Xor that don't do the check?  Similarly (A+2) > (B*3) is known to be
an arithmetic compare but the general compare will come to the same
conclusion with a few tests.  Is it worth six comparison operators to avoid
the tests on occasion?

(Of course, even more could be done if we kept track of variable contents
as well as sub-expressions.)

The actually useful things seem to be:

a) Detecting when a comparison is non-arithmetic. This avoids converting the
LHS to a number and then finding the RHS won't convert. We can detect this
for some values of constants as the operands.

b) Detecting when the arguments to a bif do not need checking. Processing
a bif instance is always two-stage; check the arguments then the rest. The
checking stage may be at compile time (Bifq$$) or run time (Bif$$). We can
detect opportunities only when the checking is on constants. (Exceptionally
something like FORMAT(A*B) doesn't need the Arith check but is that worth
bothering?)

When these constants are found to be suitable they are converted in type if
it helps, eg SUBSTR(Alpha,"7") will have the 7 held in binary.  See ConstValue.

c) Similarly for arithmetic operations, input constants are held in binary.
(The default ensures Abut$$ and Cat$$ get input constants as char strings)

d) For assignments of constants it is a matter of guesswork which
 representation is best for the constant. We guess based on the original
 source:  J=99 gets binary, J="99" gets char.
~
PcodeOpRet:
if Debug
 pop ax; Recover operator.
 mov StackDi,Z.Stackcmp StackDi,Z.Base0je Not1p
; We can do some debugging of this compile time stack accounting.
; But only on first pass.
 cmp Hg.Original,ZeroBpjne Not1ppush bxpush diz bxmov bl,al
 shr bx,1mov bl,Bptr OpFlags[bx]Qry bl,EndsClausejz @F
; Not an eoc if $pBool preceeds comparison. This test OK for debug.
 mov di,Z.Cursorcmp gs:Bptr[di-2],$pBoolje @F
 mov cx,Z.Stackmov bx,Z.Base0mov si,Z.ClauseLine
 int 3mov ax,MkMajMin(48,0)
 call Create4Dumpcall Dumperjmp Raise
@@:pop dipop bx
Not1p:;
endif
PcodeOpDone:
 pop si
 ret

if Solid
; This is information for each opcode. Order here doesn't matter, cos org'ed.
; InTypes 00b general, 01b char, 10b arith, 11b Boole.
; ResultType 00b unaltered, 01b char, 10b arith, 11b Boole
; There may also be an appended jump address.  This is determined by a range
; amongst the opcodes.
; Utility CODES.REX scans the OpFlags from here.
OpFlags:
; Flags for InTypes, ResultType, AppendNum, AppendRef, DownOne, EndsClause.
; Unary Boole:
 org OpFlags+$pNot/2OperatorRec             <3,3,0,0,0,0>
; Diadic Boole
 org OpFlags+$pXor/2OperatorRec             <3,3,0,0,1,0>
 org OpFlags+$pOr/2OperatorRec              <3,3,0,0,1,0>
 org OpFlags+$pAnd/2OperatorRec             <3,3,0,0,1,0>
; Unary arith:
 org OpFlags+$pNegate/2OperatorRec          <2,2,0,0,0,0>
 org OpFlags+$pPositive/2OperatorRec        <2,2,0,0,0,0>
; Dyadic arith:
 org OpFlags+$pIntDivide/2OperatorRec       <2,2,0,0,1,0>
 org OpFlags+$pMultiply/2OperatorRec        <2,2,0,0,1,0>
 org OpFlags+$pDivide/2OperatorRec          <2,2,0,0,1,0>
 org OpFlags+$pRemainder/2OperatorRec       <2,2,0,0,1,0>
 org OpFlags+$pSubtract/2OperatorRec        <2,2,0,0,1,0>
 org OpFlags+$pAdd/2OperatorRec             <2,2,0,0,1,0>
 org OpFlags+$pPower/2OperatorRec           <2,2,0,0,1,0>
; Dyadic char:
 org OpFlags+$pAbut/2OperatorRec            <1,1,0,0,1,0>
 org OpFlags+$pCat/2OperatorRec             <1,1,0,0,1,0>
; Bif related;
 org OpFlags+$pLength/2OperatorRec          <1,2,0,0,0,0>; Bif route.
 org OpFlags+$pMax/2OperatorRec             <2,2,1,0,0,0>; Bif route.
 org OpFlags+$pMin/2OperatorRec             <2,2,1,0,0,0>; Bif route.
 org OpFlags+$pBifq/2OperatorRec            <0,0,1,0,0,0>
 org OpFlags+$pBif/2OperatorRec             <0,0,1,0,0,0>
 org OpFlags+$pBifGroup/2OperatorRec        <0,0,1,0,0,0>
; DO parts:
; Rep$$ and Number$$ build a DO block that incorporates their argument,
; RepEver$$ incorporates a spare.  So it makes more sense to say that
; $pNumber lowers the stack and the $pControlVar does not. (It matters to the
; Bcode making utility.)
; $pNumber does have number output but shouldn't look like a binary operator.
 org OpFlags+$pNumber/2OperatorRec          <2,0,0,0,1,0>
 org OpFlags+$pTo/2OperatorRec              <2,0,0,0,1,0>
 org OpFlags+$pBy/2OperatorRec              <2,0,0,0,1,0>
 org OpFlags+$pWhile/2OperatorRec           <3,0,0,0,1,0>
 org OpFlags+$pUntil/2OperatorRec           <3,0,0,0,1,0>
 org OpFlags+$pLeave/2OperatorRec           <0,0,0,0,0,1>
 org OpFlags+$pIterate/2OperatorRec         <0,0,0,0,0,1>
 org OpFlags+$pIterRep/2OperatorRec         <0,0,0,0,0,1>
 org OpFlags+$pRep/2OperatorRec             <2,0,0,0,1,1>
 org OpFlags+$pRepEver/2OperatorRec         <0,0,0,0,0,1>
 org OpFlags+$pUnDo/2OperatorRec            <0,0,0,0,0,0>
 org OpFlags+$pFor/2OperatorRec             <2,0,0,0,1,0>
 org OpFlags+$pIterCV/2OperatorRec          <0,0,0,0,0,1>
 org OpFlags+$pControlVar/2OperatorRec      <2,0,0,1,0,1>
 org OpFlags+$pDotControlVar/2OperatorRec   <2,0,0,1,0,1>
; Jumps:
 org OpFlags+$pThen/2OperatorRec            <3,0,0,0,1,1>
 org OpFlags+$pWhen/2OperatorRec            <3,0,0,0,1,1>
 org OpFlags+$pJump/2OperatorRec            <0,0,0,0,0,0>
 org OpFlags+$pEq/2OperatorRec              <0,3,0,0,1,0>
 org OpFlags+$pNe/2OperatorRec              <0,3,0,0,1,0>
 org OpFlags+$pLt/2OperatorRec              <0,3,0,0,1,0>
 org OpFlags+$pLe/2OperatorRec              <0,3,0,0,1,0>
 org OpFlags+$pGe/2OperatorRec              <0,3,0,0,1,0>
 org OpFlags+$pGt/2OperatorRec              <0,3,0,0,1,0>
 org OpFlags+$pSeq/2OperatorRec             <1,3,0,0,1,0>
 org OpFlags+$pSne/2OperatorRec             <1,3,0,0,1,0>
 org OpFlags+$pSlt/2OperatorRec             <1,3,0,0,1,0>
 org OpFlags+$pSle/2OperatorRec             <1,3,0,0,1,0>
 org OpFlags+$pSge/2OperatorRec             <1,3,0,0,1,0>
 org OpFlags+$pSgt/2OperatorRec             <1,3,0,0,1,0>
 org OpFlags+$pCeq/2OperatorRec             <1,3,0,0,1,0>
 org OpFlags+$pCne/2OperatorRec             <1,3,0,0,1,0>
 org OpFlags+$pClt/2OperatorRec             <1,3,0,0,1,0>
 org OpFlags+$pCle/2OperatorRec             <1,3,0,0,1,0>
 org OpFlags+$pCge/2OperatorRec             <1,3,0,0,1,0>
 org OpFlags+$pCgt/2OperatorRec             <1,3,0,0,1,0>
 org OpFlags+$pReturn/2OperatorRec          <0,0,0,0,0,1>
 org OpFlags+$pCallOn/2OperatorRec          <0,0,1,1,0,1>
 org OpFlags+$pSignalOn/2OperatorRec        <0,0,1,1,0,1>
 org OpFlags+$pSignal/2OperatorRec          <0,0,0,1,0,1>
 org OpFlags+$pCall/2OperatorRec            <0,0,0,1,0,1>
 org OpFlags+$pInvoke/2OperatorRec          <0,0,1,1,0,0>
 org OpFlags+$pRaise/2OperatorRec           <0,0,1,0,0,0>
; Assignments:
 org OpFlags+$pAssignConst/2OperatorRec     <0,0,0,1,1,1>
 org OpFlags+$pAssign/2OperatorRec          <0,0,0,1,1,1>
 org OpFlags+$pUnstore/2OperatorRec         <0,0,0,0,0,0>
 org OpFlags+$pAssignStem/2OperatorRec      <0,0,0,1,1,1>
 org OpFlags+$pAssignDots/2OperatorRec      <0,0,0,1,1,1>
 org OpFlags+$pAssignDotsP/2OperatorRec     <0,0,0,1,0,0>
; Others. Nop sometimes with THEN so cannot use for EndsClause test.
 org OpFlags+$pNop/2OperatorRec             <0,0,0,0,0,0>
 org OpFlags+$pParse/2OperatorRec           <0,0,1,0,0,0>
 org OpFlags+$pDots/2OperatorRec            <0,0,1,1,1,0>
 org OpFlags+$pBool/2OperatorRec            <0,0,0,0,0,0>; Too soon for result.
 org OpFlags+$pNumeric/2OperatorRec         <0,0,1,0,1,1>
 org OpFlags+$pExit/2OperatorRec            <0,0,0,0,0,1>
 org OpFlags+$pReturns/2OperatorRec         <0,0,0,0,1,1>
 org OpFlags+$pDrop/2OperatorRec            <0,0,0,1,0,0>
 org OpFlags+$pExpose/2OperatorRec          <0,0,0,1,0,0>
 org OpFlags+$pDropList/2OperatorRec        <0,0,0,0,1,0>
 org OpFlags+$pExposeList/2OperatorRec      <0,0,0,1,0,0>
 org OpFlags+$pAddress/2OperatorRec         <0,0,0,0,0,1>
 org OpFlags+$pEnvName/2OperatorRec         <1,0,0,0,1,0>
 org OpFlags+$pCommand/2OperatorRec         <1,0,0,0,1,1>
 org OpFlags+$pCommandEnv/2OperatorRec      <1,0,1,0,0,0>
 org OpFlags+$pResumeParse/2OperatorRec     <0,0,0,0,0,0>
 org OpFlags+$pResult/2OperatorRec          <0,0,0,0,1,1>
 org OpFlags+$pInterpret/2OperatorRec       <1,0,0,0,1,1>
 org OpFlags+$pOptions/2OperatorRec         <1,0,0,0,1,1>
 org OpFlags+$pPush/2OperatorRec            <1,0,0,0,1,1>
 org OpFlags+$pQueue/2OperatorRec           <1,0,0,0,1,1>
 org OpFlags+$pTrace/2OperatorRec           <1,0,0,0,1,1>
 org OpFlags+$pSignalOff/2OperatorRec       <0,0,1,0,0,1>
 org OpFlags+$pSignalV/2OperatorRec         <0,0,0,0,1,1>
 org OpFlags+$pInterpEnd/2OperatorRec       <0,0,0,0,0,1>
 org OpFlags+$pSay/2OperatorRec             <1,0,0,0,1,1>
 org OpFlags+$pSysVar/2OperatorRec          <0,0,0,0,0,0>
 org OpFlags+$pTraceEvent/2OperatorRec      <0,0,1,0,0,0>
 org OpFlags+$PcodesCeil

;------------------------------------------------------------------------------
; This is the tie-in between lexical values and Pcode operators.
;------------------------------------------------------------------------------
; To get freedom over the numbers corresponding to Pcodes, there is a
; translation table from syntax code ($s) to the opcode in the Pcode.
; AL contains the operator. SI is in use for the parser frame.
; DI can be used.

; After the freedoms in group order have been used, there are numeric
; relations between the codes for the syntax elements. These are made
; use of in actions when materializing the $s codes.  The $s codes are
; nearly compact but not in the best order for execution so there is
; later a $s to $p conversion.
; The relations that have to be fitted around are:
;BBBBBB  B           BB     BBBBBBBBBBBB                     BB  B
;                                          V   VV  VVVVV   V   VV
;                                            U   UU
;          P   PPP P   P   P
;         S   S   S
;                                       NN  N
;                                                       III
;      DD   DD
;                       LMM
; Also see intervals for DROP & EXPOSE type.(Got this wrong & had to fixup.)
; Also see needs of PosPlus PosMinus PosEq. (Would like to fit here but
; actually used flags.)
; Also need Length-Max-Min sequential.
S2P:
 Assert $sPercent eq $-S2P
BaseB equ $-$Percent
 Assert $ eq BaseB+$Percentdb $pIntDivide
 Assert $ eq BaseB+$Asteriskdb $pMultiply
 Assert $ eq BaseB+$Slashdb $pDivide
 Assert $ eq BaseB+$Remdb $pRemainder
 Assert $ eq BaseB+$Xordb $pXor
 Assert $ eq BaseB+$Ordb $pOr
; DROP and EXPOSE are treated together. Also DropList and ExposeList
 BaseD equ $-$DROP
 Assert $sDrop eq $-S2P
 Assert $ eq BaseD+$DROPdb $pDrop
 db $pExpose
 Assert $ eq BaseB+$Anddb $pAnd
; STEM/STREAM/NORMAL are treated together
BaseS equ $-$STEM
 Assert $sStem eq $-S2P
 Assert $ eq BaseS+$STEMdb $nStem
; PARSE sources are done together.
BaseP equ $-$WITH
 Assert $sWith eq $-S2P
 Assert $ eq BaseP+$WITHdb $nWith
 Assert $sDropList eq $-S2P
 db $pDropList
 db $pExposeList
 Assert $ eq BaseS+$STREAMdb $nStream
; Historically there were opcodes like $pLineIn but latest is to use markers.
 Assert $ eq BaseP+$LINEINdb $nLineIn
 Assert $ eq BaseP+$SOURCEdb $nSource
 Assert $ eq BaseP+$VERSIONdb $nVersion
 Assert $ eq BaseS+$NORMALdb $nNormal
 Assert $ eq BaseP+$PULLdb $nPull
 db 0 ; Spare
 Assert $sMinus eq $-S2P
 Assert $ eq BaseB+$Minusdb $pSubtract
 Assert $ eq BaseB+$Plusdb $pAdd
 Assert $ eq BaseP+$VARdb $nVar
 Assert $sLength eq $-S2P
 db $pLength
 db $pMax
 db $pMin
 Assert $ eq BaseP+$ARGdb $nArg
; Eq was forced to top of its group, in order to make comparisons compact.
 Assert $sEq eq $-S2P
 Assert $ eq BaseB+$Eqdb $pEq
 Assert $ eq BaseB+$Nedb $pNe
 Assert $ eq BaseB+$Ltdb $pLt
 Assert $ eq BaseB+$Ledb $pLe
 Assert $ eq BaseB+$Gedb $pGe
 Assert $ eq BaseB+$Gtdb $pGt
 Assert $sSeq eq $-S2P
 Assert $ eq BaseB+$Seqdb $pSeq
 Assert $ eq BaseB+$Snedb $pSne
 Assert $ eq BaseB+$Sltdb $pSlt
 Assert $ eq BaseB+$Sledb $pSle
 Assert $ eq BaseB+$Sgedb $pSge
 Assert $ eq BaseB+$Sgtdb $pSgt
; NUMERIC components are done together.
BaseN equ $-$DIGITS
 Assert $sDigits eq $-S2P
 Assert $ eq BaseN+$DIGITSdb $nDigits
 Assert $ eq BaseN+$FUZZdb $nFuzz
 db 0; $sTailed was here, now unneeded
; Several verbs are done together.
BaseV equ $-$NOP
 Assert $sNop eq $-S2P
 Assert $ eq BaseV+$NOPdb $pNop
 Assert $sForm eq $-S2P
 Assert $ eq BaseN+$FORMdb $nForm
BaseU equ $-$Not
 Assert $ eq BaseU+$Notdb $pNot
 Assert $sAddress eq $-S2Pdb $pAddress
 Assert $ eq BaseV+$INTERPRETdb $pInterpret
 Assert $ eq BaseV+$OPTIONSdb $pOptions
 Assert $sNegate eq $-S2P
 Assert $ eq BaseU+$Minusdb $pNegate
 Assert $sPositive eq $-S2P
 Assert $ eq BaseU+$Plusdb $pPositive
 Assert $sExit eq $-S2P
 Assert $ eq BaseV+$EXITdb $pExit
 Assert $ eq BaseV+$PUSHdb $pPush
 Assert $ eq BaseV+$QUEUEdb $pQueue
 Assert $sReturns eq $-S2P
 Assert $ eq BaseV+$RETURNdb $pReturns
 Assert $ eq BaseV+$SAYdb $pSay
 Assert $sNumber eq $-S2Pdb $pNumber
 db 0;
 Assert $sRaise eq $-S2Pdb $pRaise
 Assert $ eq BaseV+$TRACEdb $pTrace
 db 0; was $sCatDot now unneeded.
 Assert $ eq BaseB+$Abutdb $pAbut
 Assert $ eq BaseB+$Catdb $pCat
 Assert $sLeave eq $-S2P
 Assert $ eq BaseV+$LEAVEdb $pLeave
 Assert $sIterate eq $-S2P
 Assert $ eq BaseV+$ITERATEdb $pIterate
 Assert $ eq BaseB+$Powerdb $pPower
endif

Scode:push bxmov bx,S2P; For XLATxlat cs:Bptr[bx]; Pick up Pcode.
 pop bxjmp PcodeOp

;------------------------------------------------------------------------------
; Here is where values are directly put into the code segment.
; Pcode2 with Z.Synch=0 puts two bytes of original code in.
; Pcode2 with Z.Synch\=0 adjusts Z.Cursor by 2 to reflect bytes made earlier
; and also makes two bytes dual code at Hg.Avail if DualGen is on.
; So Pcode2 is used when making original, when synching, and when original
; and dual code are to be the same.
; When original and dual are not to be the same:
; Pcode2S is Pcode2 without possibility of making dual code.
; Pcode2D makes the dual code without adjusting Z.Cursor.
; Assert DualGen on implies Z.Synch\=0
;------------------------------------------------------------------------------
Pcode2:Qry Z.Gen,DualGenjnz Pcode2DSame
Pcode2S:mov CursorBx,Z.Cursorcmp ZeroBp,Z.Synchjne NotOrig
; Original make.
if Debug
 cmp CursorBx,Hg.Availje @Fint 3@@:
endif
 call PcodeSafeGsBxmov gs:Wptr[CursorBx],axadd Hg.Avail,2
NotOrig:add Z.Cursor,2push CursorBxinc2 CursorBx
PcodeRet:cmp Z.Synch,ZeroBpje @F
 cmp CursorBx,Z.Synchje SynchMatch
@@:pop CursorBxret

Pcode2DSame:Qry Z.Gen,DualOnlyjnz Pcode2Dadd Z.Cursor,2
Pcode2D:mov CursorBx,Hg.Availcall PcodeSafeGsBxmov gs:Wptr[CursorBx],ax
 add Hg.Avail,2ret

Pcode1:Qry Z.Gen,DualGenjnz Pcode1DSame
Pcode1S:mov CursorBx,Z.Cursorcmp ZeroBp,Z.Synchjne @F
 call PcodeSafeGsBxmov gs:Bptr[CursorBx],alinc Hg.Avail
@@:inc Z.Cursorpush CursorBxinc CursorBxjmp PcodeRet

Pcode1DSame:Qry Z.Gen,DualOnlyjnz Pcode1Dinc Z.Cursor
Pcode1D:mov CursorBx,Hg.Availcall PcodeSafeGsBxmov gs:Bptr[CursorBx],al
 inc Hg.Availret

PcodeSafeGsBx:; Called when extending Pcode - may need to enlarge the segment.
@@:cmp CursorBx,Hg.Triggerjb @F
 push dimov di,Zshape.Codecall MoreSpaceEspop dimv gs,es
 mov SymbolsEs,Z.Symbolsjmp @B
@@:ret

BackOff2:sub Z.Cursor,2cmp Z.Synch,ZeroBpjne @Fsub Hg.Avail,2@@:ret

; Sometimes synchronizing is just to get .MN or msg setup.
SynchMatch:Qry Z.Gen,Dualjz Terminate
; In this case we have synched in order to setup making dual pcode as we
; continue to the next clause.
 move Z.DualCode,Hg.Avail,bx; Where code for clause will be made.
 On Z.Gen,DualPending
 pop CursorBxret

;------------------------------------------------------------------------------
; Generation for Operands.
;------------------------------------------------------------------------------
comment~ Targets, ie LHS of assign or in parse, must be delayed if tailed,
because code made now would be in the wrong place.  If not tailed it can be
looked up, but the result has to be held over for the right place in code.
There can be more than one held up (when parse template) so this is producing a
list.

Symbols that look like names have to be uppercased early so that they can be
checked against keyword lists. So it makes sense to look them up early.

Constants gain from delayed resolution - by the time they are looked up we can
have more information on the operations they are involved in. (An advantage,
at least in principle.)

Labels come in both forms but anyway are suitable for lookup without delay.
~
Action0:; The uppercased symbol will be sitting in the Symbols segment.
; Except in the case of a target with dots, it will get looked up.
; Dots are not significant if symbol is taken as a constant.
 Qry Z.Middles,LookLabeljnz Lookup; And from there ret to Action0 caller.
 Qry Z.Clause,Tailedjnz Action0Dots
; Undotted, can be resolved now.
 call Lookup; Result to Z.Resolved
; A target will be held over on the stack, a CheckDO symbol will be held in
; Resolved until the check is made.
 Qry Z.Middles,TargetSymbol,CheckDOjz QueryLoad; Result into Pcode.
; A case like LEAVE ABC does not need resolved ABC kept on the stack.
 Qry Z.Middles,TargetSymboljz Action0ret
; But ABC= does.
 call UpStackmove V.HeldOver,Z.Resolvedmov V.Dtype,$NullString
Action0ret:ret

comment~
There are complexities about the performance of compound variables.  Timing
isn't easy because of the coarse granularity of the DOS timer tick and because
any change of implementation can have its effect masked by speed changes due
solely to code being aligned differently, but I have done experiments.

The simplest way to implement a dotted reference is to have a $pCatDot operation
that concatenates two parts of a tail, putting a dot between them. The stemmed
lookup then always has one argument. (There has to be lookahead to prevent
NOVALUE arising from fetch of the tail values but that is not too bothersome.)
Sadly, this is not efficient; there has to be a memory allocation for the
$pCatDot result and often that result has to be copied into the stem's set of
keys.

The more efficient way is to just stack the tail parts and put a count of them
on the subsequent operation.  The tail parts can then be copied directly into
the stem's space (with dots between). This seems to make a difference of 60K in
the 1000K clauses per second target.

For an assignment, A.B.C=99, the tail count is deduced from the current
number of items on the stack but that doesn't work for sources, eg f(X,A.B.C).
So the counter is on $pDots only.

An implied count for the simplest cases would be an space improvement and maybe
a speed improvement since lookup can be done with the tail in its uncopied
position. This is not yet implemented.

Fetch from a stem (eg SAY A.) is no different from fetching from an ordinary
variable.  However assignment (A.=99) has extra work to do beyond setting
the default value; some elements may be exposed and these must also be
assigned to.
~

ChkDO:On Z.Middles,TakenConstantcall Lookup
; eg LEAVE A.B - just need Z.Resolved for comparison.
 sub Z.Stack,$StrideVret

Action0Dots:call UpStack
; CheckDO is for symbol with END/ITERATE/LEAVE.
; Dotted CheckDO subject - resolved as "A.B".
 Qry Z.Middles,CheckDOjnz ChkDO
; Usual dotted - On soft stack as a string.
 mv ds,esmov si,Hd.Availmovzx cx,Bptr[si]inc cx
 push axcall ResultSpacepush dimov di,axrep movsbpop dipop ax
 mov SymbolsEs,Z.Symbols
; Unless a target, the Pcode for the dotted reference will be made now.
 Qry Z.Middles,TargetSymboljz @FOff Z.Clause,Tailedret
; In execution tail components stack but during compile they don't.
@@:; This type awkward in PARSE.
 btr Z.Clause,InParsejnc @Fmov al,$mParseEscapecall Pcode1@@:
 call Lookup
; Delay the $pDots because it may be $Drop instead.
 sub Z.Stack,$StrideV

; At this time Z.Resolved is set but before we put the reference in the Pcode
; there are some cases to test where this isn't just a load.
QueryLoad:
; DROP abc and EXPOSE abc are not NOVALUE positions so best if opcode
; precedes operand. On the other hand DROP (abc) is a NOVALUE position.
; EXPOSE (abc) is a NOVALUE position where EXPOSE happens before getting
; the value.
; So maybe best is DROP A => $pDrop A, EXPOSE A => $pExpose A,
; DROP A. => $pDrop A., EXPOSE A. => $pExpose A.,
; DROP A.B => B $pDrop A., EXPOSE A.B => B $pExpose A.
; DROP (A) => A $pDropList, EXPOSE (A) => $pExposeList A
; DROP (A.B) => A.B $pDropList, EXPOSE (A.B) => B $pExposeList A.
; For a.b or (a.b) the tails are already in the Pcode and Z.Resolved is a.
 mov ax,Z.KWFoundcmp ax,$DROPje IsDropcmp ax,$EXPOSEjne PcodeLoadX
 sub al,3; Fix 'cos I got EXPOSE value wrong.
; Here with DROP and EXPOSE
IsDrop:add al,$sDrop-$DROP
; Opcode to absorb whether argument is a list.
 cmp Z.TokWas,$Lparenjne @Fadd al,$sDropList-$sDrop@@:
; DropList has no post argument.
 cmp al,$sDropListje DropList
 Off Z.Clause,WasTailed
 jmp Scode; And the $pDrop/$pExposed will add Z.Resolved (without load).

; WasTailed must be cleared for next lookup.
DropList:btr Z.Clause,WasTailedpush ax
 jc @Fcall PcodeLoadpop axjmp Scode

@@:OpAl $pDots; Flags on $pDots will add Z.Resolved.
 pop axjmp Scode

PcodeLoadX:btr Z.Clause,WasTailedjnc PcodeLoad
 call UpStack
 call UpStack
 OpAl $pDots
 mov V.Dtype,$Variable
 jmp PcodeLoadRet

PcodeLoad:; Puts the latest operand into Pcode with value to stack.
; Often it will be a variable and "value" will be synthetic.
 mov ArrayBx,Z.Resolvedcall UpStack
; If is a constant, it's value is around. Else synthesize a general value.
 mov V.Dtype,$Variabletest bl,7jz IsVar
; That test isn't quite good enough because some persistent variables, eg .MN,
; are in segment for "constants". Nine is always first constant, cf Reserved.
 cmp bx,$?Ninejae UsualCon
 mov V.Dtype,$Sigl
; This type awkward in PARSE.
 btr Z.Clause,InParsejnc IsVar
 mov al,$mParseEscapepush bxcall Pcode1pop bxjmp IsVar
UsualCon:
; Well, we do have the value in Vbx. but now is a bit early to load it because
; we don't know what type it will be used as. Better just record the instance.
; We may be able to pick up what the constant became after conversion, so
; later passes have it right without conversion.
 cmp Z.Synch,ZeroBpje UCorig
 mov CursorBx,Z.Cursor
; Can't be AssignConst case here, but original could be.
 cmp Bptr gs:[CursorBx],$pAssignConstjne @Finc CursorBx@@:
 mov ArrayBx,gs:[CursorBx]
UCorig:mov V.Dtype,$Constantmov V.WhichCon,ArrayBx
 move V.PcodePos,Hg.Avail
IsVar:
 mov ax,ArrayBxcmp V.Dtype,$Sigljne @F
 push axcall Pcode2OpAl $pSysVarpop axmov V.Dtype,$Variablejmp PcodeLoadRet

; Is the Pcode position where this operand is to go two bytes on from the
; last assignment target?
@@:
if ForBcode
 jmp Pcode2
endif
 mov CursorBx,Z.Cursordec2 CursorBxcmp CursorBx,Z.LastTargetjne Pcode2Via
; If so, is what was stored then the same as the load now?
 mov dx,axadd dx,$CaseTarget
 cmp dx,gs:[CursorBx]jne Pcode2Via
 push ax
 OpAl $pUnstore
 pop ax
; That won't be right for the tracing version.
 Qry Z.Gen,DualGenjz @F
 dec Hg.Avail
 call Pcode2D; replace with ordinary load.
@@:
PcodeLoadRet:test al,7mov ah,$TraceVarjz @Fmov ah,$TraceLit@@:
 jmp TraceEvent

Pcode2Via:call Pcode2jmp PcodeLoadRet
;------------------------------------------------------------------------------
; Generation of specific sequences.
;------------------------------------------------------------------------------
Action1:; Assignment
; There are various opcodes associated with assignment.
; $pAssign covers the majority of cases.
; $pAssignDots handles the A.B.C=99 sort.
; $pAssignStem handles the A.=99 sort.
; $pStore is an optimization for where the value is needed again. A=exp;if A...
; $pAssignConst is an optimization for RHS constant. A=99
; $pControlVar when the assignment is part of DO header activity. DO J=....
; $pDotControlVar when the assignment is part of DO header activity with a
; compound.  Both DO A.B=... and DO A.=....
; Assignments also happen within $pParse complex.
 cmp S1.State,$DoFrameje ControlVar
MakeAssign:EvAh $TraceAssign
; Top stack item corresponds to is RHS, one below the LHS.
; We will set cx up to indicate constant.
; return dx=0 except when tails.
 z cxcmp V.Dtype,$Constantjne @Finc cx
; We don't know how the LHS is going to be used, so deciding a representation
; for the value is guesswork.
 z ahcall ConstValueX
@@:Down; Removing the RHS
 mov Z.Stack,StackDi
; LHS on the stack says what sort of target it is.
 cmp V.Dtype,$NullStringjne DotsLHS
; The LHS was not tailed and was resolved earlier.
 move Z.Resolved,V.HeldOver
; Bit of an afterthought here - we can't use the simple constant assignment
; code when the target is a stem.
 mov ds,Z.Varsmov bx,axmov bx,Vbx.Here
; SymbolsEs:bx now addresses "counted string" form of name.
; Does it end with dot?
 movzx dx,Bptr SymbolsEs:[bx]add bx,dxcmp Bptr SymbolsEs:[bx],'.'
 z dxje StemTgt
; If the RHS was a constant we can use a Pcode that doesn't check so much.
; This was only 15% faster in execution, despite avoiding stack.
; (Usual doubts about accuracy of measurement)
; DI has the stack item for the target.
; CX nonzero indicates constant being assigned.
if ForBcode eq 0
 test cx,cxjz NotAssignConst
 z Z.LastTarget; Can't use $pUnstore after this.
; The dual code will not be the same, so flag fiddling.
; We need to save/restore a single flag - not simple.
 btr Z.Gen,DualGenpushf
; The RHS is already on the Pcode, at a different place than wanted, original.
; The RHS is already on the Pcode, in midst of AssignConstant, subsequently.
 call BackOff2mov CursorBx,Z.Cursor
; If Synch, the $pAssignConst is already made. Pick up RHS and traverse.
 cmp Z.Synch,ZeroBpjz @Finc CursorBx@@:
; AX is the LHS. Place $pAssignConst RHS LHS
 mov cx,Wptr gs:[CursorBx]
 mov Z.Resolved,cxpush axOpAl $pAssignConstpop axcall Pcode2
 popfjnc @FOn Z.Gen,DualGen@@:
 Qry Z.Gen,DualGenjz @F
 call UpStack
 On Z.Gen,DualOnly
 mov Z.Resolved,ax
 OpAl $pAssign
 Off Z.Gen,DualOnly
@@:ret

endif

; Z.LastTarget is used when a subsequent operand is fetched, to possibly
; change $pAssign to $pStore.
; OpAl has special tests for $pAssign, so it may get omitted.
NotAssignConst:OpAl $pAssignmov Z.LastTarget,CursorBxret

StemTgt:mov Z.LastTarget,ZeroBpOpRet $pAssignStem

; Compound name hasn't been looked up yet.
DotsLHS:mov dx,Hg.Availmov TokNumAh,$VAR_SYMBOLOn Z.Clause,Tailed
 mov StackDi,Z.Stack
 call Lookup
; Now have tails put in Pcode set, PartCountCl set, and Z.Resolved target.
 OpRet $pAssignDots

Action2:; Keyword instructions
; Pick out some simple verbs.
 mov ax,Z.KWFoundcmp ax,$NOPjb OtherVerbcmp ax,$TRACEja OtherVerb
 add al,$sNop-$NOP
; Faster to have a distinct Pcode for RETURN without argument.
 cmp al,$sReturnsjne Scode
 cmp StackDi,Z.Base0jne Scode
 OpRet $pReturn

OtherVerb:Qry Z.Clause,Signal; Copes with SIGNAL and NAMEjnz SignalVerb
 Qry Z.Clause,WasParsejz ActionRet
; Cannot be in InParse??
@@:Qry Z.Clause,InParsejnz @FOpAl $pResumeParse
@@:sub Z.Stack,$StrideVmov al,$mParseEndjmp Pcode1

Action3:; end of commandOpRet $pCommand

Action6:; PARSE VALUE
 mov Z.KWMiddle,$WithKey
ActionRet:
 ret

Action11:; Unary operator
; Need to alter + and -. Alters Not also.
 add S.Token,$sNegate-$sMinus
 mov ah,$TracePrefixjmp @F

Action10:; Binary operator
 mov ah,$TraceOperator
@@:push axcall ActionBincall Scodepop ax

TraceEvent:; Compile time note of tracing potential.
 Qry Z.Gen,DualGenjnz @Fret@@:
 mov al,$pTraceEventjmp Pcode2D

Action12:; Comparisons.
comment~ There are alternative designs possible. Ideally, we would have opcodes
for the six comparison results, times three for strict, non-strict, known
non-arithmetic. (Known arithmetic not much of an optimization because the
check is quick.) Also times another three for result-to-stack, result is
absolute jump, result is (one byte) relative jump.

To avoid getting too expensive on opcodes, I have postponed using relative jumps
(which needs an extra pass) and made the result-to-stack mechanism a prefix
to the opcode.
~
; Change from $s codes to $p ones. Simple to do that without the XLAT table.
 call ActionBinadd al,aladd al,$pEq-2*$sEq
; Specialize further, maybe.
 cmp al,$pSeqjae Action12Asis
; If either known to be non-arith then make it a char one.
; ie constants that don't have number syntax.
; Even if we don't know it is arith, it probably helps to use arith const
; where possible.
 mov ah,'N'
 cmp V.Dtype,$Constantjne @F
 call ConstValueX
; The flags from NumDxBx in ConstValueX are available here.
 jc Action12Char; Non number syntax so must be char compare.
 jmp Action12Asis

@@:cmp V0.Dtype,$Constantjne Action12Asis
 Downcall ConstValueXUpCarejnc Action12Asis
Action12Char:; A non-strict compare without arithmetic checks.
if ForBcode eq 0
 add al,$pCeq-$pEq
endif
Action12Asis:; Make the long form initially. It may get optimized.
 push axOpAl $pBoolpop axinc CursorBx
 mov Z.CompareAt,CursorBxcall PcodeOp
; Comparison operators have space for a jump value, except when $pBool precedes.
; The tables say 'make space' but we don't want it here.
 call BackOff2
 Qry Z.Gen,DualGenjz @Fsub Hg.Avail,2@@:
 EvRet $TraceOperator

; S.Token was set by the parser on encountering the operator.  Now is the
; time to take it from the parser state and put it in the Pcode.
; ActionBin puts it in al.
ActionBin:move Z.InsOperator,S.Operation
 mov al,Bptr S.Tokenadd al,$sPercent-$Percentret

Action18:; Save function name over the arglist.
 mov ax,Z.Resolvedmov S.Caller,axmov S.Parms,StackDi
Action18Ret:ret

; It would be nice to have had a utility to sort out different actions
; and how they share variables but that is not yet mechanised.

$SelectFrame equ 2*363 ; S112 W177   SELECT ncl^....
$IfFrame equ 2*345 ; S48 W63         ifexpr.91 ^ ncl
$DoFrame equ 2*435 ; S8 W9           DO ^ ....

Action20:; THEN
; The THEN of IF and the THEN of WHEN differ only in the message number when the
; subject is non-Boolean. We could save a code point by using a rescan to
; determine that but I have chosen the simpler approach of a different Pcode.
; ?? Rescan for line number anyway.

; Here we find a place of the parser stack where we can store info (FillJump)
; and recover it at the end of the THEN part. (Action 21, Action 22)
; Similarly for SELECT.

 mov al,$pWhen
 cmp S.State,$IfFrameje UseS1
; Looks like can be different for THEN when THEN starts new line.
 cmp S1.State,$IfFramejne @Fadd ParseSi,$StrideSjmp UseS1@@:
 cmp S1.State,$SelectFrame
 jne @Fz S1.SelectSiteinc Z.TraceOnlyjmp UseS1w@@:
 add ParseSi,$StrideS
; Test S1 (was S2 on entry)
 cmp S1.State,$SelectFrameje UseS1w
 add ParseSi,$StrideS
 cmp S1.State,$SelectFrameje UseS1w
 Error49Bp
; A compare made a $pBool followed by a $pEq or similar. This leaves the
; comparison result on the stack. A $pThen now with target would do the
; conditional jump. We optimize by accepting that sequence with $pBool and
; $pThen bytes left out. However, trace and optimizing don't combine.
UseS1:mov al,$pThen
; Cannot use Hd.Avail as test value because label can get to array before it
; appears with a label.
 move S1.SoFar,Hg.Avail,dx; See traceonly test.
UseS1w:mov dx,Z.CompareAtz Z.CompareAtadd dx,1cmp dx,Z.Cursorjne @F
 call Shortenjmp EndThen
@@:call PcodeOp; $pThen/$pWhen retained.
 mov S1.JumpSite,CursorBx
; The 'then' is a separate clause.
; QueryKey did a ClauseSourceEnd when THEN keyword, for what was ahead of THEN.
; Here is one for the THEN itself.
EndThen:mov CursorSi,Z.Scanpcall ClauseSourceEnd
 jmp Action91

Shorten:; We have made Bool-Compare when just Compare wanted on short form.
; That's true of first time but later we will have just just stepped over
; so compare-op has to be found somewhere different.
 mov CursorBx,Z.Cursorcmp Z.Synch,ZeroBpje @Fdec CursorBx@@:
 mov dl,Bptr gs:[CursorBx-1];The $pEq like.
 mov dh,al
; Generate twice, with differing flags for original and trace code.
; Saving of individual flag is clumsy.
 btr Z.Gen,DualGenpushf
 call BackOff2mov al,dlcall PcodeOpmov S1.JumpSite,CursorBx
 popfjnc @FOn Z.Gen,DualGen@@:
 Qry Z.Gen,DualGenjz @F
; Already made Bool-Comp-TraceEvent[Expr]
 On Z.Gen,DualOnlymov al,dhcall PcodeOpOff Z.Gen,DualOnly
@@:ret

Action21:; ELSE
 OpAl $pJumpmov dx,CursorBxxchg S.JumpSite,CursorBx
 call FillJump
 mov CursorSi,Z.Scanpcall ClauseSourceEnd
; If we are doing synch for a trace of an ELSE leg we actually want two
; lines, one for the ELSE and one for the first clause of the leg.
; Normally the Z.Synch would take us to the latter because the branch from
; THEN goes there, not to any Pcode from ELSE.
; The Pcode from ELSE will be the jump 3 bytes before that.
; If we detect this case, we can get the ELSE, then repeat the synch for
; the clause.
; That works when the ELSE leg is to be executed.
; In the alternate case, when the THEN leg is executed. We want to take the
; jump that is at the end of the THEN leg but not show the ELSE keyword that
; corresponds to the jump. See the place that outputs source during tracing.
 Qry Z.Program,ShowELSEjz Action91
 Qry Z.Gen,Dualjz Action91
 add dx,2cmp dx,Z.Synchjne Action91
; End the compile with the flag still on.  Higher level will test
 jmp Terminate

; FillJump is always filling a forward reference with a branch to the current
; end of generated code.
; Only fill in the branch targets once. (Not on scans for line numbers.)
FillJump:mov ax,Z.Cursorcmp Z.Synch,ZeroBpjne SynchTarget
 mov gs:[CursorBx],ax
; Can't optimize over branch-in points.
@@:z Z.LastTargetret

SynchTarget:cmp ax,gs:[CursorBx]je @Bint 3Error49Bp

Action22:; if completion.
; May need to mark labels trace-only, first pass.
 cmp Hg.Original,ZeroBpjne @F
; Looks at labels.
; Clumsy to scan through constants after every IF. Should chain off IF. NYI
 mov ProgEs,Z.ProgScope
 mov ds,Z.Constsmov ArrayBx,Hd.Avail
Action22L:sub ArrayBx,$StrideV
 cmp ArrayBx,$SizeConstsHeaderjb @F
; Here for each constant since start of IF.
 cmp Vbxe.Dtype,$Labeljne Action22L
; Here if a label.
 mov ax,Vbxe.LabelValueTestReg axjz Action22L
; Here if it has appeared with a colon.
 cmp ax,S.SoFarjb Action22L
; Here if not pointing to before the IF.
 cmp ax,Hg.Availje Action22L
; Here if not at the end of this if clause.
 mov Bptr Vbxe.LabelType,1; Marks trace-only
 jmp Action22L

@@:mov SymbolsEs,Z.Symbols
 mov CursorBx,S.JumpSitejmp FillJump

Action23:; select; JumpSite zeroed by otherwise.
 cmp S.JumpSite,ZeroBpje @F
; Substitute otherwise is message 7.3
 mov OpAppendCl,$n7p3OpAl $pRaise
; NYI also the S.ClauseWas field of the SELECT frame.
@@:mov di,S.SelectSitez Z.LastTarget
; There is a chain of forward branch sites.
 cmp Z.Synch,ZeroBpjne Action22Ret
; Fill them all.
 mov cx,Z.Cursor
@@:mov si,gs:[di]mov gs:[di],cxmov di,siTestReg dijnz @B
Action22Ret:ret

Action24:; otherwise; Mark JumpSite with zero.
; 2011 added variety??
; +2 then +1 then +1 instead  of +3 then +1
 add ParseSi,2*$StrideScmp S.State,$SelectFrameje @F
 add ParseSi,$StrideScmp S.State,$SelectFrameje @F
 add ParseSi,$StrideScmp S.State,$SelectFrameje @F
 Error49Bp
@@:z S.JumpSiteret

comment~ We made no special actions in the BNF for detecting 'trace-only' labels
so that is done with ad-hoc rules.  We detect 'END' in QueryKey to count down
Z.TraceOnly.  We count it up on 'DO'.  The keyword SELECT is not specially
detected so to count up for that we actually count in the action for the first
WHEN of the select.  This count allows us to detect trace-onlys within DO-END
and SELECT-END by Z.TraceOnly > 0.

For IF things are harder because IF A THEN NOP;ABC:  is traceonly when an ELSE
follows.  It seems that IF should record the Pcode position when it starts.
When it ends, the labels for places at least as high as that recorded are
traceonly, unless they are equal to the current position.  (This assumes that an
ELSE, even ELSE NOP, makes some code.)

~
Action25:; when completion.
 cmp S1.State,$SelectFrameje @F
 add ParseSi,$StrideS
 cmp S1.State,$SelectFrameje @F
 add ParseSi,$StrideS
 cmp S1.State,$SelectFrameje @F
 Error49Bp
@@:OpAl $pJump; WHEN end requires a branch to end of SELECT.
 cmp Z.Synch,ZeroBpjne @F
 mov ax,S1.SelectSitemov Wptr gs:[CursorBx],axmov S1.SelectSite,CursorBx
; THEN at start of this WHEN is a jump to here.
@@:mov CursorBx,S1.JumpSitejmp FillJump

Action26:; PROCEDURE.  Make protection against fall-thru.
 mov OpAppendCl,$n17p1OpRet $pRaise

Raise28:mov ah,28cmp Bptr Z.KWFound,low $LEAVEje @Finc ax@@:jmp Raise

Action28:; ITERATE/LEAVE without VAR_SYMBOLmov al,1
; Scan the stack, looking for DO repetitive.
@@:add ParseSi,$StrideScmp S.State,ZeroBpje Raise28
 Qry S.Parser,DoRep,DoCVjz @B
 jmp A29Pcode
Action29:; VAR_SYMBOL after LEAVE or ITERATEmov al,1
; Scan the stack, looking for DO info.
@@:add ParseSi,$StrideScmp S.State,ZeroBpje Raise28
 Qry S.Parser,DoCV,DoRepjz @BQry S.Parser,DoRepjnz A29UnDo
 call CompNamesje A29Pcode
A29UnDo:OpAl $pUnDomov al,3jmp @B

; Different types of DO use a different iterate Pcode, for speed.
A29Pcode:cmp Bptr Z.KWFound,low $LEAVEjne @FOpRet $pLeave@@:
FromDoEnd:mov al,$pIterateQry S.Parser,Foreverjnz @F
 mov al,$pIterCVQry S.Parser,DoCVjnz @Fmov al,$pIterRep
@@:jmp PcodeOp

ControlVar:; Here for DO j=1 TO 99 type of assign.
; We need something in the Pcode because numberness has to be checked
; before TO BY FOR are done and actual assignment done after.
 OpAl $pNumber
; The generation for the assignment is held over the BY etc.
; Carry some info over for the END (and LEAVE/ITERATE)
; Note that the S2.State won't be a DO one, it is just a carrier.
 On S2.Parser,DoCV,DoDataHostOn Z.Clause,CVar
; The LHS has been soft stacked for hold over the RHS expression.
; We need to remember it for the whole DO group for test of match at END.
; So for DO J=1 we remember the resolved J in the hard stack.
; For DO A.K=1 we look up A.K as the constant "A.K".  Could be a bit
; wasteful since execution may never need that constant, but convenient.
 cmp V.Dtype,$NullStringjne @Fmov ax,V.HeldOver
CVret:mov S2.WhatCV,axret; Leave assignment to Action33.

@@:; We will be able to detect later that WhatCV is dotted by its constantness.
; Here we look it up as a constant. Action33 will do it as tailed.
; Copy symbol saved on stack back to Z.Symbols where Lookup expects it.
 push ParseSipush StackDicall ToDsSiCx
; Check space early because compaction in loop intolerable.
 mov di,He.Availadd di,cxcall SymbolsSafe
 pop StackDicall ToDsSiCxpush StackDi
 mov di,He.Availrep movsbpop StackDipop ParseSi
 On Z.Middles,TakenConstantcall Lookupmov ax,ArrayBxjmp CVret

Action30:; After do-end, without name.ret

Action31:; After do-end, with name.
; Since this name is the latest token there is more than one way to reach it.
 move Z.ClauseLine,S.ClauseWas
 mov ax,MkMajMin(10,2); Msg for mismatch.
 Qry S.Parser,DoCVjnz HasDoCVinc ax
@@:jmp Raise
HasDoCV:call CompNamesjne @Bret

; Set zero flag iff CV name matches latest token.
CompNames:mov ArrayBx,Z.Resolvedcmp ArrayBx,S.WhatCVret

Action32:; Complete the do group with a loop address if repetitive.
 Qry S2.Parser,DoDataHostjnz @FAdd ParseSi,$StrideS@@:
 Qry S2.Parser,DoCV,DoRepjz @F
; Adjustment of Parser stack so we can share code.
 add ParseSi,$StrideS*2call FromDoEnd
 mov CursorBx,S.JumpSitecall FillJump
@@:ret

; FOREVER is like $pRep with no argument. (So why $pRepEver?)
Action36:
Action33:; dorep done. Change middle keyword list.
; Make S1 the one filled before.
 cmp S.State,$DoFrameje @Fadd ParseSi,$StrideScmp S.State,$DoFrameje @F
 add ParseSi,$StrideScmp S.State,$DoFrameje @FError49Bp@@:
@@:mov Z.KWMiddle,$CondKeysOn Z.Clause,Repit
; Parser stack is not consistent so not easy to test for DoCV. Hence flag.
 Qry Z.Clause,CVarjz NoCV
; The code generation is not entirely like assignment. The control variable
; needs to be recorded at run time. A different opcode reflects this.
; Also, if there is WHILE or UNTIL, the opcode will not be one that marks
; end-of-clause.
; We also put an argument on this operation to set up the LEAVE target.
; There are two opcodes, the usual $pControlVar and the $pDotControlVar
; which is for either the CV is a stem or is tailed.
; Share code with ordinary assign by making an assignment, then changing the
; opcode.
 call UpStack; mock RHS
 On Z.Cancel,AssignDO
 call MakeAssign
 Off Z.Cancel,AssignDO
; A further complication occurs when the control variable is tailed,
; 'thunking' is needed.
; I've done that by having MakeAssign set dx to the value needed.
 test cx,cxjnz Action33Tailed
 mov al,$pControlVar
 xchg al,Bptr gs:[CursorBx-1]
 cmp al,$pAssignje @F
; Add the space for jump address after the reference to the control variable.
Action33j:mov Bptr gs:[CursorBx-1],$pDotControlVar
@@:call Pcode2; To make space.
Action33c:mov S1.JumpSite,CursorBxret

Action33Tailed:call Action33j
; Use a subcode to show where loop should branch back to reload tail(s).
 mov al,$mRepTailcall Pcode1xax dxjmp Pcode2

NoCV:cmp StackDi,Z.Base0jne @FOn S1.Parser,Forever,DoDataHost
@@:On S1.Parser,DoRep,DoDataHostmov al,$pRepEver
 Qry S1.Parser,Foreverjnz @Fmov al,$pRep@@:call PcodeOpjmp Action33c

Action34:; WHILE expOpRet $pWhile

Action35:; UNTIL exp OpAl $pUntil
; Target jump around UNTIL to here.
 mov CursorBx,Z.UntilPlacejmp FillJump

Action37:; Keywords WHILE/UNTIL
; If there has been no repetition we need to invent one.
 Qry Z.Clause,Repitjnz @Fcall Action33@@:
 cmp Z.KWFound,$UNTILjne @F; Make jump around the until code.
 OpAl $pJumpmov Z.UntilPlace,CursorBx
@@:ret

; Z.KWFound doesn't work out for Middle keywords.
Action381:OpRet $pTo
Action382:OpRet $pBy
Action383:OpRet $pFor

Action41:; Invent for missing parameter.
 call UpStack
 mov V.Dtype,$Omittedmov ax,$?Omittedjmp Pcode2
Action43:; Function completes. Place invoker name in pcode.
 call ActInvokeCl
; Whether Bif or not, there will be function result on this route.
 pushfcall UpStack
; Unknown compile time values are set to be something that will fail bif tests.
 mov V.Dtype,$Variable
 popfjc @F; Carry means it is bif, Pcode was made.
; Pcode for non-bif made here.
; Parameter count before the target makes it easier to share with CALL.
 move Z.Resolved,S1.Callermov al,$pInvokecall PcodeOp
@@:EvRet $TraceFunction

Action44:sub si,$StrideS; After call without parameters.
Action45:call ActInvokeCljc BifCall
 move Z.Resolved,S1.CallerOpRet $pCall

; Call, if Bif, needs to put result in special variable .RESULT
; We could have flagged $pResult as not DownOne since this is only usage.
BifCall:call UpStackOpRet $pResult

ActInvokeCl:; Set Z.Stack back to pre-invoke
; Set carry iff this is a bif.
; If not bif, return parameter count in cl.
; If bif syntax error presence/number of parameters wrong, make syntax Pcode.
; If bif non-error put the Pcode to call it as a function.

; Setup StackDx to StackDi as lo:hi retained range. Equal means none.
 mov StackDx,S1.Parmsmov Z.StackLo,StackDxpush StackDx
; Pop of StackDx value to Z.Stack will effect removal of the args.
; Trailing commas don't count.
@@:cmp StackDi,StackDxje @Fcmp V.Dtype,$Omittedjne @F
 Downcall BackOff2jmp @B
@@:call SetStack; Reflect retained args.
; Set cx to number of parms.
 mov ParmsCx,StackDisub ParmsCx,StackDxshr ParmsCx,$ShiftV
 cmp ParmsCx,$MaxParmsja ArgsLim
; Test apparent location to determine bifness.
 mov ArrayBx,S1.Callermov fs,Z.ProgScopemov bx,fs:Vbx.LabelValue
 sub bx,$BifBasejnb @Fpop Z.Stackclcret@@:
 call PcodeBifpop Z.Stackstcret

ArgsLim:mov dl,$DescArgsjmp Raise5p1

Action51:;ARG verb is same as PARSE UPPER ARG
Action52:;PULL verb is same as PARSE UPPER PULL
 On Z.Clause,WasUpper
Action50:;After the subject of PARSE
 On Z.Middles,TargetSymbol,DotOK; For target names
 On Z.Clause,InParse,WasParse
 mov ax,Z.KWFoundadd al,$sWith-$WITH
 mov bx,S2Pxlat cs:Bptr[bx]; Pick up marker.
 cmp al,$nWithjbe @Fcall UpStack
 mov V.Dtype,$Variable
@@:
 mov OpAppendCl,al
 EvAh $TraceParse
 OpAl $pParse
 mov ax,Z.Stackmov Z.OnSoft,ax
 Qry Z.Clause,WasUpperjnz @Fret
@@:mov al,$mUpperjmp Pcode1

comment~ The aim is to construct a complete PARSE instruction out of markers
and operand references, without Pcodes after $pParse. Where that would result
in something too complex for Parse$$ to interpret (eg a compound reference)
then some Pcode is introduced, bracketed by $mParseEscape and $pResumeParse.
(or ended with $pAssignDotsP)
To generate the bracketing, flag InParse is set here when the parse is normal.
The hard cases elsewhere see the flag, make $mParseEscape ahead of their stuff,
and turn off the flag. Here we see the flag off and generate $pResumeParse.
~

Action53:;Trigger.
 bts Z.Clause,InParsejc @F
; It was turned off if $mParseEscape was made.
 OpAl $pResumeParse
@@:mov al,$mPosPlusbtr Z.Clause,PosPlusjc TriggerValue
 mov al,$mPosMinusbtr Z.Clause,PosMinus
; Stop on neg positional as debug trick.
 jnc @Fint 3jmp TriggerValue@@:
 mov al,$mPatternbtr Z.Clause,PosEqjc Positional
 cmp Z.TokNow,$NUMBERjne TriggerValue
Positional:mov al,$mPosEq
TriggerValue:; Unless it is pattern we would prefer argument as a number.
 cmp al,$mPatternje @F
 mov ah,'N'call ConstValue
@@:sub Z.Stack,$StrideV
PostTrigger:call Pcode1
; Any targets that were before this trigger can now be dealt with.
; they range from above Z.OnSoft to Z.Stack.
 mov StackDi,Z.OnSoftpush StackDijmp TestTarsUp

TarsLoop:; If it was resolved, it is sufficient just to put it as a target.
; NYI StemTarget?
 push StackDicmp V.Dtype,$NullStringjne TgtTailed
 mov ax,V.HeldOveradd ax,$CaseTarget
 push StackDicall Pcode2pop StackDijmp @F
; Tail calculation is introduced by $mParseEscape.
TgtTailed:mov al,$mParseEscapecall Pcode1pop StackDipush StackDi
; Compound name hasn't been looked up yet.
 mov dx,Z.Cursormov TokNumAh,$VAR_SYMBOLOn Z.Clause,Tailed
 call Lookup
; Now have tails put in Pcode set, PartCountCl set, and Z.Resolved target.
; Doesn't look like we can use $pAssignDots because extra on stack.
 OpAl $pAssignDotsP
@@:pop StackDi
TestTarsUp:Upcmp StackDi,Z.Stackjbe TarsLoop
; Stack resets to Z.OnSoft
 pop Z.StackOn Z.Middles,TargetSymbol,DotOKret

Action55:; +-= ; Sets PosPlus, PosMinus or PosEq flag.
mov ax,Z.TokNowsub ax,$Minusbts Z.Clause,axret

Action56:; UPPER On Z.Clause,WasUpperret

Action57:; Trigger for last set in the template.
 mov al,$mPosRestjmp PostTrigger

Action58:; Comma in template
 On Z.Middles,TargetSymbol,DotOK; For target names
 mov al,$mTemplateCommajmp Pcode1

ConditionNum:mov cx,Z.Condition
; Set OpAppendCl for subsequent PcodeOp.
; Fiddle to correct order for testing.
 cmp cl,$NOTREADYjne @Fdec cx@@:cmp cl,$ERRORjne @Fsub cl,4@@:
 add cl,1-$LOSTDIGITS
; Now Syntax,LostDigits,NoValue,NotReady,Error,Failure,Halt
 ret

Action60:; callon specmov al,$pCallOn
Action60x:Qry Z.Clause,OffFlagjz CallOn
 call ConditionNumOpRet $pSignalOff

CallOn:cmp Z.KWFound,$NAMEje @F
; The condition looked up as a keyword is still around raw to be a constant.
 On Z.Middles,LookLabel,TakenConstantmov TokNumAh,$VAR_SYMBOLcall Lookup
@@:call ConditionNumjmp PcodeOp

Action61:mov ax,Z.KWFoundmov Z.Condition,axOn Z.Clause,Conditionret

Action62:On Z.Clause,OffFlagret

SignalVerb:
 mov al,$pSignalOnQry Z.Clause,Conditionjnz Action60x; Join CALL ON
; Lookup has distinquished SIGNAL ABC and SIGNAL VALUE ABC.(Labels not stacked)
 cmp StackDi,Z.Base0je @F
 OpRet $pSignalV

; SIGNAL ABC, argument not on stack.
; We could save code by converting this to be like VALUE "ConstSymbol" but
; using another opcode makes execution much faster.
@@:OpRet $pSignal

; This is setup to use just one opcode $pCommandEnv with value following for
; STEM/STREAM/NORMAL + in/out/err + append.
Action70:; ADDRESS instruction completes.
 move Z.Stack,Z.Base0
 OpRet $pAddress

Action71:; INPUT resourcesmov OpAppendCl,offset EnvBlock.EnvResourceI
A7n:
; Add flags to those in OpAppendCl.
 mov ax,Z.KWFoundadd al,low($sStem-$STEM)
 mov bx,S2Pxlat cs:Bptr[bx]or OpAppendCl,al
 OpRet $pCommandEnv

Action72:; OUTPUT resourcesmov OpAppendCl,offset EnvBlock.EnvResourceO
@@:btr Z.Clause,Appendjnc A7nor OpAppendCl,080hjmp A7n

Action73:; ERROR resourcesmov OpAppendCl,offset EnvBlock.EnvResourceEjmp @B

Action74:; APPENDOn Z.Clause,Appendret

Action75:; Environment name. Can be VALUEd so needs runtime lookup.
 OpRet $pEnvName

Action80:; numerics
; We could have set up the BNF so as to have separate actions but that
; would have meant duplicated code here.
; We could do the defaults dynamically without noticeable loss of speed
; but we choose compile time.
; First construct subcode and done if there is an operand.
 mov ax,Z.KWFoundadd al,$sDigits-$DIGITS
; Simplest to work out default even when it might not be needed.
; Provide default operand. Tied in with order of groups and $Reserved.
; $?Nine: (9 0 '' 'E' 'S') on Reserved
; DIGITS,FUZZ, ,NOP,FORM on Scodes.
; Adjust to stride for constants (the defaults).
 push axmov ah,$StrideVmul ah
; If bigger than $sForm it will be Engineering/Scientific.
; Else DIGITS...FORM range fits 9...'S' range.
 cmp ax,$StrideV*$sFormjna @F
; Subcode becomes FORM for ENGINEERING/SCIENTIFIC keywords.
 pop bxmov bl,$sFormpush bx
; Adjust for values 'E' and 'S'.
; Cancel the $DIGITS factor and substitute $ENGINEERING.
; Cancel the $?Nine factor (coming later) and substitute $?E.
; The brackets below help the assembler!
 add ax,($?E)-($?Nine)-($ENGINEERING-$DIGITS)*$StrideV
@@:cmp StackDi,Z.Base0jne HaveValue
 add ax,$?Nine-$StrideV*$sDigitscall Pcode2add Z.Stack,$StrideV
HaveValue:pop ax
 mov bx,S2Pxlat cs:Bptr[bx]mov OpAppendCl,al
 OpRet $pNumeric

Action90:; Trace event for end-of-expression.
 EvRet $TraceExpr

Action91:; Can use NOP as an end-of-clause marker, if one is needed.
 Qry Z.Middles,EndClausejz @F
 OpRet $pNop
; Trace event for end-of-clause
@@:Qry Z.Gen,DualGenjz NotDualGen
; Compiling for dual mode.
 EvAh $TraceEndClause
if Debug
; Make dump show newest code.
 call Create4Dump
 call Dumper
endif
; One clause at a time is compiled in dual mode.
 Qry Z.Gen,Dualjnz Terminate
 ret

; If the Z.Synch was for tracing, the following clause needs
; dual code generated.
NotDualGen:btr Z.Gen,DualPendingjnc @FOn Z.Gen,DualGen@@:ret

;------------------------------------------------------------------------------
; Terminate the code made when Cycle reaches end of source.
; Used from Syntax.
;------------------------------------------------------------------------------
Terminate:z Z.Scanp
 move Z.Stack,Z.Base0,StackDi
 cmp Z.Synch,ZeroBpjne NoTrailer
; ?? Probably need a flag for TraceBack anyway so Exit & InterpEnd could share?
 mov al,$pExitbtr Z.Program,LabelsBadjnc NotInterpmov al,$pInterpEnd
NotInterp:call PcodeOp
NoTrailer:
; Does this every time because code segment could have extended.
; Note results of compilation.
; Is there a problem that we should update F.Code as soon as Z.Code changes,
; avoiding situation when compaction in between would save both versions??
 lds bx,Z.SysFile
 On F.Flags,BeenCompiled
 move F.Symbols,Z.Symbols
 move F.Code,Z.Code
 move F.Consts,Z.Consts
 move F.Vars,Z.Vars
 move F.ProgScope,Z.ProgScope
 mov sp,Z.ParseResetSp
 ret

 end
